// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <fennec/lang/detail/_stdlib.h>
#include <fennec/string/cstring.h>

void _assert_callback(const fennec::cstring& expr, const fennec::cstring& file, int line, const fennec::cstring& func, const fennec::cstring& desc);

void _assert_impl(const char* expr, size_t expr_l,
				  const char* file, size_t file_l, int line,
				  const char* func, size_t func_l,
				  const char* desc, bool halt)
{
	_assert_callback(
		fennec::cstring(expr, expr_l),
		fennec::cstring(file, file_l), line,
		fennec::cstring(func, func_l),
		fennec::cstring(desc, ::strlen(desc))
	);

	if (halt) {
		::abort();
	}
}